package pontoVenda;

public class CadastroPontoVenda {


private RepositorioPontoVenda rep;


/**  * Construtor da classe CadastroPontoVenda
     *
     * @param repPv    Repositorio de Pontos de Venda criado na fachada
     */
public CadastroPontoVenda ( RepositorioPontoVenda repPv) {
        rep = repPv;
   }


  // ................. MTODOS ....................


/**  * Inserir Ponto de Venda
     *
     * @param   pv   Objeto Ponto de Venda a ser Inserido
     */

    public void inserirPontoVenda(PontoVenda pv)  {
        rep.inserirPontoVenda(pv);
    }



/**  * Excluir  Ponto de Venda
     *
     * @param   pv   Ponto de Venda a ser Excluido
     */

    public void excluirPontoVenda(PontoVenda pv) {
       rep.excluirPontoVenda(pv);
    }



/**  * Seleciona Ponto de Venda e devolve os selecionados
     *
     * @param   pv   Ponto de Venda com requisitos de seleo
     */

    public PontoVenda[] selecionarPontoVenda(PontoVenda pv) {
       return rep.selecionaPontoVenda(pv);

    }


/**  * procura se o Ponto de Venda existe e devolve True ou False
     *
     * @param   pv   Ponto de Venda a ser verificado
     */

    public boolean procurarPontoVenda(PontoVenda pv) {
       return rep.procurarPontoVenda(pv);

    }



  //  Devolve um array com Pontos de Venda

    public PontoVenda[] getArrayPontoVenda() {
        return rep.getArrayPontoVenda();
    }
}

