package pontoVenda;

public class Loja extends PontoVenda {


    /*** Construtor da classe Loja.
     * @param numeroPontoVenda    Numero da Loja
     * @param nomePontoVenda      Nome da Loja
     * @param fonePontoVenda      Telefone da Loja
     * @param pisoPontoVenda      Piso onde se encontra a Loja
     * @param corredorPontoVenda  Corredor onde se encontra a Loja

   */
    public Loja(int numeroPontoVenda, String nomePontoVenda, String fonePontoVenda,
                String pisoPontoVenda, int corredorPontoVenda){
      super(numeroPontoVenda, nomePontoVenda, fonePontoVenda,
            pisoPontoVenda, corredorPontoVenda);
    }

    public Loja() {
    }

  // ............. MTODOS ..........................


 /** Retorna true se for uma Loja e falso se nao for
    *
    * @return  True se PontoVenda for Loja e False se for Quiosque
    */
   public boolean isLoja() {
     return true;
    }

/**  *Mtodo Match - Verifica se o objeto atende s condies
     * especificadas num objeto enviado
     */
    public boolean match(PontoVenda pv){
      boolean resultado = true;
       if (pv.getNumeroPontoVenda() > 0 ) {
         if (this.getNumeroPontoVenda() != pv.getNumeroPontoVenda())
            return resultado = false;
       }
       if (pv.getNomePontoVenda() != null) {
         if (this.getNomePontoVenda() != pv.getNomePontoVenda())
            return resultado = false;
       }
       if (pv.getFonePontoVenda() != null) {
         if (this.getFonePontoVenda() != pv.getFonePontoVenda())
            return resultado = false;
       }
       if (pv.getPisoPontoVenda() != null) {
         if (this.getPisoPontoVenda() != pv.getPisoPontoVenda())
            return resultado = false;
       }
       if (pv.getCorredorPontoVenda() > -1) {
         if (this.getCorredorPontoVenda() != pv.getCorredorPontoVenda())
            return resultado = false;
       }
      return resultado;
    }


} // Fecha Classe

