package pontoVenda;

public class Quiosque extends PontoVenda {


    private int referenciaQuiosque;

    /*** Construtor da classe Quiosque.
     * @param numeroPontoVenda    Numero da Loja
     * @param nomePontoVenda      Nome da Loja
     * @param fonePontoVenda      Telefone da Loja
     * @param pisoPontoVenda      Piso onde se encontra a Loja
     * @param corredorPontoVenda  Corredor onde se encontra a Loja
     * @param referenciaQuiosque  Loja referencia do Quiosque

   */
    public Quiosque(int numeroPontoVenda, String nomePontoVenda, String fonePontoVenda,
                String pisoPontoVenda, int corredorPontoVenda,
                int referenciaQuiosque){
      super(numeroPontoVenda, nomePontoVenda, fonePontoVenda,
            pisoPontoVenda, corredorPontoVenda);

      this.referenciaQuiosque = referenciaQuiosque;
    }

    public Quiosque() {
    }


  // ............. MTODOS ..........................


 /** Retorna true se for uma Loja e falso se nao for
    *
    * @return  True se PontoVenda for Loja e False se for Quiosque
    */
   public boolean isLoja() {
     return false;
    }


  /** Retorna a referencia do Quiosque, que  o nunero da Loja
    * na qual o Quiosque fica em frente
    *
    * @return o numero da Loja em frente ao Quiosque
    *
    */
   public int getReferenciaQuiosque() {
      return this.referenciaQuiosque;
    }


/**  *Mtodo Match - Verifica se o objeto atende s condies
     * especificadas num objeto enviado
     */
    public boolean match(PontoVenda pv){
      boolean resultado = true;
       if (pv.getNumeroPontoVenda() > -1 ) {
         if (this.getNumeroPontoVenda() != pv.getNumeroPontoVenda())
            return resultado = false;
       }
       if (pv.getNomePontoVenda() != null) {
         if (this.getNomePontoVenda() != pv.getNomePontoVenda())
            return resultado = false;
       }
       if (pv.getFonePontoVenda() != null) {
         if (this.getFonePontoVenda() != pv.getFonePontoVenda())
            return resultado = false;
       }
       if (pv.getPisoPontoVenda() != null) {
         if (this.getPisoPontoVenda() != pv.getPisoPontoVenda())
            return resultado = false;
       }
       if (pv.getCorredorPontoVenda() > -1) {
         if (this.getCorredorPontoVenda() != pv.getCorredorPontoVenda())
            return resultado = false;
       }
       if (((Quiosque)pv).getReferenciaQuiosque() > -1) {
         if (this.getReferenciaQuiosque() != ((Quiosque)pv).getReferenciaQuiosque())
            return resultado = false;
       }
      return resultado;
    }



} // Fecha Classe

