package pontoVenda ;

/*
 Esta Interface modela modela um Repositorio de Pontos de Venda

 com suas Lojas ou Quiosques e operaes sobre eles
*/

interface RepositorioPontoVenda {


// .............. MTODOS ...........................


/* Insere um novo Ponto de Venda na lista.
     *
     * @param           Um Ponto de Venda a ser inserido
     */
  void inserirPontoVenda(PontoVenda pv);



/* Exclui um Ponto de Venda da lista.
     *
     * @param           Nome do Ponto de Venda a ser excluida.
     */

  void excluirPontoVenda(PontoVenda pv);


/* Procura se um dado Ponto de Venda pertence  lista.
     *
     * @param           Nome do Ponto de Venda a ser procurada.
     * @return          Resposta se o Ponto de Venda existe.
     */

  boolean procurarPontoVenda(PontoVenda pv);


/* Retorna um array de Pontos de Venda
     *
     */

  PontoVenda[]  getArrayPontoVenda();


/**  * Seleciona Ponto de Venda e devolve os selecionados
     *
     * @param   pv   Ponto de Venda com requisitos de seleo
     */

    public PontoVenda[] selecionaPontoVenda(PontoVenda pv);





} // Fecha Classe


