package pontoVenda ;


/*
 Esta Classe modela um conjunto de Pontos de Venda em forma de lista

Ponto de Venda pode ser uma Loja ou um Quiosque
*/

public class RepositorioPontoVendaLista
             implements RepositorioPontoVenda {

 // o Ponto de Venda deste n da Lista
  private PontoVenda  noPontoVenda;

 // referencia ao proximo elemento da lista
  private RepositorioPontoVendaLista proxPontoVenda;



// .............. MTODOS ...........................


 /* Insere um novo Ponto de Venda na lista.
     *
     * @param           Um Ponto de Venda a ser inserido
     */
  public void inserirPontoVenda(PontoVenda pv) {

     if (!this.procurarPontoVenda(pv)) {
        if (this.noPontoVenda == null) {
            this.noPontoVenda = pv;
            proxPontoVenda = new RepositorioPontoVendaLista();
        }
        else
            proxPontoVenda.inserirPontoVenda(pv);
      }
      else
        {throw new RuntimeException ("Ponto de Venda ja Cadastrado!");   }

   }

 /* Exclui um Ponto de Venda da lista.
     *
     * @param           Nome do Ponto de Venda a ser excluida.
     */
    public void excluirPontoVenda(PontoVenda pv) {
        if (this.noPontoVenda == null)
            throw new RuntimeException ("Ponto de Venda inexistente");
        else {
            if (this.noPontoVenda.match(pv)) {
                this.noPontoVenda = proxPontoVenda.noPontoVenda;
                this.proxPontoVenda = proxPontoVenda.proxPontoVenda;
            } else
                proxPontoVenda.excluirPontoVenda(pv);
        }
    }

    /* Procura se um dado Ponto de Venda pertence  lista.
     *
     * @param           Ponto de Venda a ser procurada.
     * @return          Resposta se o Ponto de Venda existe.
     */
    public boolean procurarPontoVenda(PontoVenda pv){
      PontoVenda pVenda = null;
      boolean resultado = false;
      IteratorPontoVendaArray itPv = new IteratorPontoVendaArray();
      PontoVenda[] arrPv = this.getArrayPontoVenda();

      while (itPv.hasNext(arrPv)) {
       pVenda = itPv.next(arrPv);
       if (pVenda.match(pv))
        return resultado = true;
      } // fecha o while

      return resultado = false;

    }

/**  * Seleciona Ponto de Venda e devolve os selecionados
     *
     * @param   pv   Ponto de Venda com requisitos de seleo
     */

    public PontoVenda[] selecionaPontoVenda(PontoVenda pv) {

      PontoVenda pVenda = null;
      PontoVenda[] selPv = null;
      int indice = 0;
      IteratorPontoVendaArray itPv = new IteratorPontoVendaArray();
      PontoVenda[] arrPv = this.getArrayPontoVenda();

      while (itPv.hasNext(arrPv)) {
       pVenda = itPv.next(arrPv);
       if (pVenda.match(pv)) {

        selPv[indice] = pVenda;
        indice = indice+1;
       } // fecha o if
      } // fecha o while

      return selPv;

    }


    // Retorna um array de Pontos de Venda

    public  PontoVenda[]  getArrayPontoVenda() {
      PontoVenda[] arrayPv;
      int indice = 0;
      RepositorioPontoVendaLista repoPv = new RepositorioPontoVendaLista();
      arrayPv = new PontoVenda[100];

      repoPv = this;

      while (repoPv.noPontoVenda != null) {
          arrayPv[indice] = repoPv.noPontoVenda;
          indice = indice+1;
          repoPv = repoPv.proxPontoVenda;
        }

      return arrayPv;

    }


} // Fecha Classe


