package produto;

public class CadastroMarca {
	private RepositorioMarca rep;
	
	/**  * Construtor da classe CadastroMarca
	     *
	     * @param repMarca      Repositorio de Marcas criado na fachada
	*/
	public CadastroMarca(RepositorioMarca repMarca) {
		rep = repMarca;
	}
	
	// ................. MTODOS ....................	
	
/**  * Inserir Marca no Repositrio
     *
     * @param m      Objeto Marca a ser Inserido
    */

	public void inserirMarca (Marca m) {
		rep.inserirMarca(m);
	}


/**  *  Excluir Marca no Repositrio
     *
     * @param m      Objeto Marca a ser Excluido
    */

	public void excluirMarca (Marca marca) {
		rep.excluirMarca(marca);
	}


/**  * Verifica se marca existe e devolve True ou False
     *
     * @param m      Objeto Marca a ser pesquisado
    */

	public boolean procurarMarca (Marca marca) {
		return rep.procurarMarca(marca);
	}


/**  *  Devolve um array com todas as Marcas cadastradas
     *
     */

    public Marca[] getArrayMarca() {
        return rep.getArrayMarca();
    }


/* Seleciona as Marcas que atendem a uma condio inicial
 *  @param   m   Objeto Marca com as informaes necessrias
 *
 */
    public Marca[] selecionarMarca(Marca m) {
        return rep.selecionarMarca(m);
    }


}// Fim da classe CadastroMarca