package produto;

import setor.Setor;

public class Produto {



  private String nomeProduto;    // Nome do Produto
  private Setor setor;            // Setor do  Produto
  private RepositorioPerfilProdutoLista perfilProdutos; // Coleo de Perfis do Produto

  /**  * Construtor da classe Produto.
     *
     * @param tipo   Nome do Produto
      @param setor    Nome do Setor do Shopping Center
     */

    public Produto(String nomeProduto, Setor setor){
        this.nomeProduto = nomeProduto;
        this.setor = setor;
        perfilProdutos = new RepositorioPerfilProdutoLista();
    }


    public Produto()  {
     }

    public Produto(String nomeProduto, Setor setor, RepositorioPerfilProdutoLista perfis){
        this.nomeProduto = nomeProduto;
        this.setor = setor;
        perfilProdutos = perfis;
    }

  // ..................... MTODOS ....................

  //   Retorna o Nome do Produto.

    public String getNomeProduto() {
        return this.nomeProduto;
    }

  // Retorna o Nome do Setor do Produto.

    public String getNomeSetorProduto() {
        return setor.getNomeSetor();
    }

    // Retorna o Setor do Produto.

    public Setor getSetorProduto() {
        return this.setor;
    }

 // .................................................

     /** Insere um novo Perfil desse Produto
     *
     * @param codigoProduto   Cdigo do produto (com aquele perfil)
     * @param sexo            Sexo dos usurios que podem fazer uso do produto
     * @param idMin           Idade Minima dos Usuarios do Produto
     * @param idMax           Idade Mxima dos Usuarios do Produto
     * @param marca           Marca do Produto
     * @param detalhe         Detalhes especficos do produto
     */
     public void inserirPerfilProduto(PerfilProduto pp) throws PerfilJaCaException {
        perfilProdutos.inserirPerfilProduto(pp);
    }

    /**
     * Exclui um Perfil desse Produto
     *
     * @param           codigo do Produto (com aquele perfil)
     */
    public void excluirPerfilProduto(PerfilProduto pp) throws PerfilNaoCaException {
        perfilProdutos.excluirPerfilProduto(pp);
    }

   // Procura Perfil do Produto

    public boolean procurarPerfilProduto(PerfilProduto pp) {
         return perfilProdutos.procurarPerfilProduto(pp);

         }



   /** Este metodo seleciona um array de perfis que satisfazem ao perfil
    *  buscado pelo usuario
    *
    * @param perfilP  Objeto PerfilProduto que contem as caracteristicas buscadas
    *
    */

    public PerfilProduto[]  selecionarPerfilProduto(PerfilProduto perfilP) {
          return perfilProdutos.selecionarPerfilProduto(perfilP);

    }




   /** Este metodo retorna um array de perfis de um determinado produto,
    *  nao recebe parametros
    *
    */


     public PerfilProduto[] getArrayPerfilProduto(){

        return perfilProdutos.getArrayPerfilProduto();

       }



 // Mtodo Match - Verifica se o objeto atende s condies
 // especificadas num objeto enviado

  public boolean match(Produto p) {
   boolean resultado = true;
   Setor setorP, setorThis;
   IteratorPerfilProdutoArray itPP = new IteratorPerfilProdutoArray();
   PerfilProduto[] perfilThis = null;

   int indice = 0;

   if (p.getNomeProduto() != null)  { //  1o.  if
     if (!(this.nomeProduto.equals(p.getNomeProduto()))) { //  2o. if
      return resultado = false;
      } // fecha o 2o. if
    } // fecha 1o. if

  // vou verificar o SETOR
   setorThis = this.getSetorProduto();
   setorP = p.getSetorProduto();
   if (setorP != null) { //  1o. if
    if (!(setorThis.match(setorP))) { //  2.o if
     return resultado = false;
     } //fecha o  2o. if
   } // fecha  1.o if

// *********
// vou verificar o Perfil do Produto
// o produto pesquisado so traz um perfil dentro do seu repositorio

   PerfilProduto[] pps = p.getArrayPerfilProduto();
   PerfilProduto pp = null;

   if (pps[0] != null){
     pp = pps[0];}
     boolean existePerfilIgual = this.procurarPerfilProduto(pp);
      if (!existePerfilIgual){
    return resultado=false;
    }

  return resultado;

  } // fecha o metodo

}  // Fecha Classe Produto


