package produto;
/*
 Esta Classe modela um conjunto, em forma de array, de Marca
*/

public class RepositorioMarcaArray
             implements RepositorioMarca {


	private Marca[] marcas; // Array de marcas
	private int indice; // indice do array

/* 	// Construtor da classe
 *
 */
	public RepositorioMarcaArray(){
		marcas = new Marca [100];
		indice = 0;
	}


	// .............. MTODOS ...........................


/* Insere uma nova marca no array.
 *
 * @param           Uma marca a ser inserida.
 */
	public void inserirMarca (Marca m){
   if (this.procurarMarca(m) == false)  {
		indice = indice+1;
    marcas[indice] = m;

   }
    else
     throw new RuntimeException ("Marca ja Cadastrada!");
	}

/* Exclui uma marca da lista.
 *
 * @param           marca a ser excluida.
 */
	public void excluirMarca(Marca m) {
		for (int i=1; i<indice; i=i+1) {
			if (marcas[i].match(m)){
				for (int j=i; j<indice-1; j=j+1){
					marcas[j]=marcas[j+1];
				}
				indice = indice-1;
				break;
			}
		}
	}

/* Procura se uma dada marca pertence  lista.
 *
 * @param           Marca a ser procurada.
 * @return          Resposta se a marca existe.
 */
	public boolean procurarMarca(Marca m){
		boolean resultado = false;
    Marca ma = null;

		for (int i=1; i<indice; i=i+1){
      ma = marcas[i];
			if (ma.match(m)){
				resultado = true;
				break;
			}
		}

		return resultado;
	}


/* Seleciona Marcas que atendem a uma dada condio
 *
 * @param     marca   condio a ser pesquisada.
 * @return          Resposta das Marcas que atendem a condio inicial
 */
 public Marca[] selecionarMarca(Marca marca){
		Marca[] resultado = null;
    Marca m = null;

    int j = 0;
    for (int i=1; i<indice; i=i+1){
      if (marca != null) {
        m = marcas[i];
        if (m.match(marca)){
          resultado[j] = marcas[i];
          j = j+1;
        }
      }
      else {
       resultado[j] = marcas[i];
       j = j+1;
      }
    }
   return resultado;
 }


/* Retorna um array com todas as Marcas
 *
 */

  public  Marca[]  getArrayMarca() {
    Marca[] arrayMarcas;
    int indice2 = 0;

    arrayMarcas = new Marca[100];

    while (marcas[indice2] != null) {
     arrayMarcas[indice2] = marcas[indice2];
     indice2 = indice2+1;
    }
     return arrayMarcas;

   }


}// Fim da classe RepositorioMarcaArray