package produto;

import pontoVenda.PontoVenda;

/*
 Esta Classe modela um conjunto, em forma de lista, de Ofertas de um Produto
*/

interface RepositorioOfertaProduto {




 // ............. MTODOS .......................

 /* Insere uma nova OfertaProduto na lista.
     *

     */
  public void inserirOfertaProduto(OfertaProduto ofertaProduto)
   throws OfertaJaCaException ;



 /* Exclui uma OfertaProduto da lista.
     *
     * @param           pontoVenda onde se encontra a Oferta
     */
  public void excluirOfertaProduto(OfertaProduto ofertaProduto)
   throws OfertaNaoCaException;



    /* Procura se uma dada OfertaProduto pertence  lista.
     *
     * @param           pontoVenda que possui a oferta.
     * @return          Resposta se a OfertaProduto existe.
     */
    public boolean procurarOfertaProduto(OfertaProduto ofertaProduto);



 /* Altera o preo de uma OfertaProduto da lista
     *
     * @param           pontoVenda que possui a OfertaProduto
     * @param           novo preo da OfertaProduto
     */
  public void alterarPrecoOfertaProduto(OfertaProduto ofertaProduto, double novoPreco)
    throws OfertaNaoCaException;




 // Retorna um array de OfertaProdutos

  public  OfertaProduto[]  getArrayOfertaProduto();


/*

// Retorna um array com uma seleo de OfertaProduto que satisfazem
// uma determinada OfertaProduto recebida

  public OfertaProduto[] selecionarOfertaProduto(OfertaProduto ofertaProduto);

// Recebe um array ofertaProduto e retorna uma Lista OfertaProduto semelhante

  public RepositorioOfertaProdutoLista arrayListaOfertaProduto(OfertaProduto[] ofertaProduto);


*/

} // Fecha Interface OfertaProduto


