package produto;

import pontoVenda.PontoVenda;

/*
 Esta Classe modela um conjunto, em forma de lista, de Ofertas de um Produto
*/

public class RepositorioOfertaProdutoLista
               implements RepositorioOfertaProduto {

 // a OfertaProduto deste n da Lista
  private OfertaProduto noOfertaProduto;

 // referencia ao proximo elemento da lista
  private RepositorioOfertaProdutoLista proxOfertaProduto;



 // ............. MTODOS .......................

 /* Insere uma nova OfertaProduto na lista.
     *

     */
  public void inserirOfertaProduto(OfertaProduto ofertaProduto)
    throws OfertaJaCaException {

     if (!this.procurarOfertaProduto(ofertaProduto)) {
        if (this.noOfertaProduto == null) {
            this.noOfertaProduto = ofertaProduto;
            proxOfertaProduto = new RepositorioOfertaProdutoLista();
        }
        else
            proxOfertaProduto.inserirOfertaProduto(ofertaProduto);
      }
      else
        {      throw new OfertaJaCaException() ;  }

   }

 /* Exclui uma OfertaProduto da lista.
     *
     * @param           pontoVenda onde se encontra a Oferta
     */
    public void excluirOfertaProduto(OfertaProduto ofertaProduto)
      throws OfertaNaoCaException {
        if (this.noOfertaProduto == null)
                 throw new OfertaNaoCaException();
        else {
            OfertaProduto op1 = this.noOfertaProduto;
            if (op1.match(ofertaProduto)) {
                this.noOfertaProduto = proxOfertaProduto.noOfertaProduto;
                this.proxOfertaProduto = proxOfertaProduto.proxOfertaProduto;
            }
            else
                proxOfertaProduto.excluirOfertaProduto(ofertaProduto);
        }
    }

    /* Procura se uma dada OfertaProduto pertence  lista.
     *
     * @param           pontoVenda que possui a oferta.
     * @return          Resposta se a OfertaProduto existe.
     */
    public boolean procurarOfertaProduto(OfertaProduto ofertaProduto){
        boolean resultado = false;
        if (this.noOfertaProduto == null)
            resultado = false;
        else {
            OfertaProduto op = this.noOfertaProduto;
            if (op.match(ofertaProduto))
                resultado = true;
            else
               proxOfertaProduto.procurarOfertaProduto(ofertaProduto);
          }
        return resultado;
    }

 /* Altera o preo de uma OfertaProduto da lista
     *
     * @param           pontoVenda que possui a OfertaProduto
     * @param           novo preo da OfertaProduto
     */
  public void alterarPrecoOfertaProduto(OfertaProduto ofertaProduto, double novoPreco)
   throws OfertaNaoCaException {

     if (!this.procurarOfertaProduto(ofertaProduto))
         throw new OfertaNaoCaException();
     else  {
        OfertaProduto[] ops = this.selecionarOfertaProduto(ofertaProduto);
        ofertaProduto = ops[1];
        ofertaProduto.setPreco(novoPreco);

     }
   }

     // Retorna um array de OfertaProdutos

  public  OfertaProduto[]  getArrayOfertaProduto() {
      OfertaProduto[] arrayOfertaProdutos;
      int indice = 0;

      RepositorioOfertaProdutoLista repoOp = new RepositorioOfertaProdutoLista();
      arrayOfertaProdutos = new OfertaProduto[100];

      repoOp = this;

      while (repoOp.noOfertaProduto != null) {
         arrayOfertaProdutos[indice] = repoOp.noOfertaProduto;
         indice = indice+1;
         repoOp = repoOp.proxOfertaProduto;
        }

      return arrayOfertaProdutos;

    }



/*

// Recebe um array ofertaProduto e retorna uma Lista OfertaProduto semelhante

  public RepositorioOfertaProdutoLista arrayListaOfertaProduto(OfertaProduto[] ofertaProduto) {

          RepositorioOfertaProdutoLista resultado = null;

          return resultado;


       } // fecha mtodo
*/

// Retorna um array com uma seleo de OfertaProduto que satisfazem
// uma determinada OfertaProduto recebida

  public OfertaProduto[] selecionarOfertaProduto(OfertaProduto ofertaProduto) {
      OfertaProduto[] arrOfertas = this.getArrayOfertaProduto();
      OfertaProduto[] selOfertas = null;
      int indice = 0;
      IteratorOfertaProdutoArray itOP = new IteratorOfertaProdutoArray();
      OfertaProduto op = null;

      while (itOP.hasNext(arrOfertas)) {
       op = itOP.next(arrOfertas);
       if (op.match(ofertaProduto)) {

        selOfertas[indice] = op;
        indice = indice+1;
       } // fecha if

      } // fecha o while
      return selOfertas;
    } // fecha o mtodo



} // Fecha Classe OfertaProdutoLista


