package produto;

 /*
 Esta Classe modela um conjunto, em forma de lista, de Produtos
*/

interface RepositorioPerfilProduto {





// .............. MTODOS ...........................


/** Insere um novo Perfil de um Produto na lista.
     *
     * @param codigo     Cdigo do produto (com aquele perfil)
     * @param sexo       Sexo dos usurios que podem fazer uso do produto
     * @param idMin      Idade Minima dos Usuarios do Produto
     * @param idMax      Idade Mxima dos Usuarios do Produto
     * @param marca      Marca do Produto
     * @param detalhe    Detalhes especficos do produto
     */
  public void inserirPerfilProduto(PerfilProduto pp) throws PerfilJaCaException;



/* Exclui uma Perfil do Produto da lista.
     *
     * @param           codigo do Produto (com aquele perfil) a ser excluido.
     */
    public void excluirPerfilProduto(PerfilProduto pp) throws PerfilNaoCaException;



/* Procura se um dado Perfil de um Produto pertence  lista.
     *
     * @param           codigo do produto (com aquele perfil)
     * @return          Resposta se o arquivo existe.
     */
    public boolean procurarPerfilProduto(PerfilProduto pp);




// Retorna um array de Perfis de um Produto

    public  PerfilProduto[]  getArrayPerfilProduto();


    /* Recebe um Perfil de produto e devolve um array com os perfis que atendem
     * ao recebido
     *
     */

    public PerfilProduto[] selecionarPerfilProduto(PerfilProduto pp);



// Recebe um Array de PerfilProduto e devolve um repositorioPerfilProduto
// com os perfis do array

    public RepositorioPerfilProdutoLista arrayParaLista(PerfilProduto[] pProd)
     throws PerfilJaCaException;


// Transforma um array numa lista



} // Fecha a Interface RepositorioPerfilProduto

