package produto;

 /*
 Esta Classe modela um conjunto, em forma de lista, de Produtos
*/

public class RepositorioPerfilProdutoLista
              implements RepositorioPerfilProduto {

 // O Produto deste n da Lista
  private PerfilProduto noPerfilProduto;

 // referencia ao proximo elemento da lista
  private RepositorioPerfilProdutoLista proxPerfilProduto;


  public RepositorioPerfilProdutoLista(){}

// .............. MTODOS ...........................


 /* Insere um novo Perfil de um Produto na lista.
     *
     * @param codigo     Cdigo do produto (com aquele perfil)
     * @param sexo       Sexo dos usurios que podem fazer uso do produto
     * @param idMin      Idade Minima dos Usuarios do Produto
     * @param idMax      Idade Mxima dos Usuarios do Produto
     * @param marca      Marca do Produto
     * @param detalhe    Detalhes especficos do produto
     */
  public void inserirPerfilProduto(PerfilProduto pp)
    throws PerfilJaCaException {

     if (!this.procurarPerfilProduto(pp)) { // 1o. if
        if (this.noPerfilProduto == null) {
            this.noPerfilProduto = pp;
            proxPerfilProduto = new RepositorioPerfilProdutoLista();
        }
        else
            proxPerfilProduto.inserirPerfilProduto(pp);
      } // fecha 1o. if
      else // 1o. if
        {      throw new PerfilJaCaException();
        }

   } // fecha mtodo



 /* Exclui uma Perfil do Produto da lista.
     *
     * @param           codigo do Produto (com aquele perfil) a ser excluido.
     */
    public void excluirPerfilProduto(PerfilProduto pp)
      throws PerfilNaoCaException {
        if (this.noPerfilProduto == null)
                 throw new PerfilNaoCaException();
        else {
            if (this.noPerfilProduto.match(pp)) {
                this.noPerfilProduto = proxPerfilProduto.noPerfilProduto;
                this.proxPerfilProduto = proxPerfilProduto.proxPerfilProduto;
            } else
                proxPerfilProduto.excluirPerfilProduto(pp);
        }
    }

    /* Procura se um dado Perfil de um Produto pertence  lista.
     *
     * @param           codigo do produto (com aquele perfil)
     * @return          Resposta se o arquivo existe.
     */
    public boolean procurarPerfilProduto(PerfilProduto pp){
        boolean resultado = false;
        if (this.noPerfilProduto == null)
            resultado = false;
        else
            if (this.noPerfilProduto.match(pp))
                resultado = true;
            else
                resultado = proxPerfilProduto.procurarPerfilProduto(pp);

        return resultado;
    }




     // Retorna um array de Perfis de um Produto

    public  PerfilProduto[]  getArrayPerfilProduto() {
      PerfilProduto[] arrayPerfilProdutos;
      int indice = 0;

      RepositorioPerfilProdutoLista repoPp = new RepositorioPerfilProdutoLista();
      arrayPerfilProdutos = new PerfilProduto[100];

      repoPp = this;

      while (repoPp.noPerfilProduto != null)  {
          arrayPerfilProdutos[indice] = this.noPerfilProduto;
          indice = indice+1;
          repoPp = repoPp.proxPerfilProduto;
         }

      return arrayPerfilProdutos;

    }

// Recebe um PerfilProduto e um Array de PerfilProduto devolve um repositorioPerfilProduto
// com os perfis do array que satisfazem o PerfilProduto

public PerfilProduto[] selecionarPerfilProduto(PerfilProduto pp1) {

     PerfilProduto[] resultado = null;
     IteratorPerfilProduto ipp = null;
     PerfilProduto pp = null;
     PerfilProduto[] ppThis = null;
     int indice = 0;

     ppThis = this.getArrayPerfilProduto();


     while (ipp.hasNext(ppThis)) {
      pp = ipp.next(ppThis);

      if (pp.match(pp1)) {
        resultado[indice] = pp;
        indice = indice+1;
      }  // fecha o if
     } // fecha o while

     return resultado;

     } // fecha metodo


// Recebe um Array de PerfilProduto e devolve um repositorioPerfilProduto
// com os perfis do array

    public RepositorioPerfilProdutoLista arrayParaLista(PerfilProduto[] pProd)
      throws PerfilJaCaException{
      int i=0;
      while (pProd[i] != null) {
            this.inserirPerfilProduto(pProd[i]);
            i=i+1;
        }
      return this;
    }


} // Fecha Classe  RepositorioPerfilProdutoLista



