package produto;

import setor.Setor;
import pontoVenda.PontoVenda;

/*
 Esta Classe modela um conjunto, em forma de lista, de Produtos.
*/


public class RepositorioProdutoLista
               implements RepositorioProduto {

  // O Produto deste n da Lista
  private Produto noProduto;

 // referencia ao proximo elemento da lista
  private RepositorioProdutoLista proxProduto;

// .............. MTODOS ...........................


 /* Insere um novo Produto na lista.
     *
     * @param           Um Produto a ser inserido.
     */
  public void inserirProduto(Produto produto) throws ProdutoJaCaException {

     if (!this.procurarProduto(produto)) {
        if (this.noProduto == null) {
            this.noProduto = produto;
            proxProduto = new RepositorioProdutoLista();
        } else
            proxProduto.inserirProduto(produto);
      }
      else
        {      throw new ProdutoJaCaException(produto.getNomeProduto());  }

   }

 /* Exclui uma TipoProduto da lista.
     *
     * @param           TipoProduto a ser excluida.
     */
    public void excluirProduto(Produto produto) throws ProdutoNaoCaException{
        if (this.noProduto == null)
                 throw new ProdutoNaoCaException(produto.getNomeProduto());
        else {
            if (this.noProduto.match(produto)) {
                this.noProduto = proxProduto.noProduto;
                this.proxProduto = proxProduto.proxProduto;
             }
            else
                proxProduto.excluirProduto(produto);
        }
    } // fecha mtodo

    /* Procura se um dado Produto pertence  lista.
     *
     * @param           Nome do Produto a ser procurado.
     * @return          Resposta se o arquivo existe.
     */
    public boolean procurarProduto(Produto produto){
        boolean resultado;
        if (this.noProduto == null)
            resultado = false;
        else
            if (this.noProduto.match(produto))
              resultado = true;
            else
              resultado = proxProduto.procurarProduto(produto);

        return resultado;
    }

    // Inclui Perfil de um Produto

    public void inserirPerfilProduto(Produto produto, PerfilProduto perfilProduto)
         throws ProdutoNaoCaException, PerfilJaCaException {
      if (this.procurarProduto(produto)){
       Produto[] p =  this.selecionarProduto(produto);
       Produto p1 = p[0];
       if (p1 != null)
         p1.inserirPerfilProduto(perfilProduto);
      }
        else
           throw new ProdutoNaoCaException(produto.getNomeProduto());
     } // fecha mtodo



   // Exclui Perfil de Produto
     /*
     * @param nomeProduto   Nome do Produto
     * @param codigoProduto     Cdigo do produto (com aquele perfil)
     */
    public void excluirPerfilProduto(Produto p, PerfilProduto pp)
      throws ProdutoNaoCaException, PerfilNaoCaException {
     if (this.procurarProduto(p)){
       Produto[] ps =  this.selecionarProduto(p);
       Produto p1 = ps[1];
       if (p1 != null)
         p1.excluirPerfilProduto(pp);
      }
        else
          throw new ProdutoNaoCaException(p.getNomeProduto());
     }


     // Inclui Oferta de um Produto

    public void inserirOfertaProduto(Produto p, PerfilProduto pp, OfertaProduto op)
       throws ProdutoNaoCaException, PerfilNaoCaException, OfertaJaCaException{
     if (this.procurarProduto(p)){ // 1o. if
       Produto[] ps =  this.selecionarProduto(p);
       Produto p1 = ps[1];
       if (p1 != null) { // 2o. if
         PerfilProduto[] pps = p1.selecionarPerfilProduto(pp);
         if (pps != null) {  // 3o. if
          PerfilProduto pp1 = pps[1];
          pp1.inserirOfertaProduto(op);
         } // fecha o 3o. if
         else
         { throw new PerfilNaoCaException();
         }
        } // fecha o 2o. if
      } // fecha o 3o. if
        else
        {     throw new ProdutoNaoCaException(p.getNomeProduto()); }


     }// fecha metodo

      // Exclui Oferta de um Produto

    public void excluirOfertaProduto(Produto produto, PerfilProduto perfilProduto,
               OfertaProduto ofertaProduto)
          throws ProdutoNaoCaException, PerfilNaoCaException, OfertaNaoCaException {

      Produto p = null;
      Produto[] ps = null;
      PerfilProduto[] pps = null;
      PerfilProduto pp = null;

      ps =  this.selecionarProduto(produto);
       if (ps != null){
           p = ps[1];
           pps = p.selecionarPerfilProduto(perfilProduto);
           if (pps != null) {
             pp = pps[1];
             pp.excluirOfertaProduto(ofertaProduto);
             }
           else { // 2 if
             throw new PerfilNaoCaException();
           }
        }// fecha 1 if
        else {throw new ProdutoNaoCaException(produto.getNomeProduto());} // 1 if
     }// fecha metodo

     // Altera o preo de uma Oferta de um Produto

      public void alterarPrecoOfertaProduto(Produto produto, PerfilProduto perfilProduto,
                            OfertaProduto ofertaProduto, double novoPreco)
             throws ProdutoNaoCaException, PerfilNaoCaException, OfertaNaoCaException  {

      boolean result = false;
      result =  this.procurarProduto(produto);
       if (result != false){
           Produto[] ps = this.selecionarProduto(produto);
           produto=ps[1];
           result = produto.procurarPerfilProduto(perfilProduto);
           if (result != false) {
             PerfilProduto[] pps = produto.selecionarPerfilProduto(perfilProduto);
             perfilProduto = pps[1];
             perfilProduto.alterarPrecoOfertaProduto(ofertaProduto, novoPreco);
             }
           else { // 2 if
             throw new PerfilNaoCaException();
           }
        }// fecha 1 if
        else {throw new ProdutoNaoCaException(produto.getNomeProduto());}   // 1 if
     }// fecha metodo





    // Retorna um array de produto

    public  Produto[]  getArrayProduto() {
      Produto[] arrayProdutos;
      int indice = 0;

      arrayProdutos = new Produto[100];

      while (this.noProduto != null) {
       arrayProdutos[indice] = this.noProduto;
       indice = indice+1;
       this.noProduto = proxProduto.noProduto;
       proxProduto = proxProduto.proxProduto;
        }

      return arrayProdutos;

    }

     // Retorna um array de produtos de um Setor

    public  Produto[]  getArrayProdutoSetor(Setor setor) {
      Produto[] arrayProdutos;
      Produto prod = null;
      Setor set = null;
      int indice = 0;
      RepositorioProdutoLista repoPl = new RepositorioProdutoLista();
      arrayProdutos = new Produto[100];

      repoPl = this;

      while (repoPl.noProduto != null) {
       prod = repoPl.noProduto;
       set = prod.getSetorProduto();
       if (set.match(setor)) {
         arrayProdutos[indice] = repoPl.noProduto;
         indice = indice+1;
         repoPl = repoPl.proxProduto;

        }
       }
      return arrayProdutos;

    }


    // Retorna um array com Perfil Produtos

    public PerfilProduto[] getArrayPerfilProduto(Produto produto) {
       boolean result = false;
       result = this.procurarProduto(produto);
       if (result != false)
           return produto.getArrayPerfilProduto();
         else
           return null;

    }

     // Retorna um array de Ofertas de um Produto

    public OfertaProduto[] getArrayOfertaProduto(Produto produto,
                                      PerfilProduto perfilProduto) {
       OfertaProduto[] ops = null;

       if (this.procurarProduto(produto)) {   // 1o. if
        Produto[] ps = this.selecionarProduto(produto);
        if (ps != null){ // 2o. if
            Produto p = ps[1];
            PerfilProduto[] pps = p.selecionarPerfilProduto(perfilProduto);
            if (pps != null)  { // 3o. if
              PerfilProduto pp = pps[1];
              if (pp != null) { // 4o if
                ops = pp.getArrayOfertaProduto();

               }  // 4o. if
            } // 3o. if

        }// fecha 2 if

       } // fecha 1o. if
       return ops;

     }// fecha metodo

/*  Retorna um array com Seleo de Produtos
     *
     *
     */

    public Produto[] selecionarProduto(Produto produto) {
     int indice = 0;
     IteratorProduto Ip = null;
     Produto p = null;           // produto pego no array gerado pelo  Repositrio

     Produto[] prodSel = new Produto[100];   // produto que satisfaz seleo
     Produto[] repoPro = this.getArrayProduto(); // repositorio transformado em array



     while (Ip.hasNext(repoPro)) {
      p = Ip.next(repoPro);


      if (p.match(produto)){
        prodSel[indice] = p;
        indice = indice+1;
        }

     } // fecha o while

     return prodSel;

    }  // fecha o mtodo



} // Fecha Classe  RepositorioProdutoLista


