package setor;

import pontoVenda.PontoVenda;
import pontoVenda.RepositorioPontoVendaLista;

public class CadastroSetor {


private RepositorioSetor rep;


/**  * Construtor da classe CadastroSetor
     *
     * @param repSetor        Repositorio de Setor criado na fachada
     */
public CadastroSetor ( RepositorioSetor repSetor) {
        rep = repSetor;
   }


  // ................. MTODOS ....................


/**  * Inserir Setor no Repositrio
     *
     * @param m      Objeto Setor a ser Inserido
     */

    public void inserirSetor(Setor setor)  {
        rep.inserirSetor(setor);
    }

/**  *  Excluir Setor no Repositrio
     *
     * @param m      Objeto Setor a ser Excluido
    */

    public void excluirSetor(Setor setor) {
       rep.excluirSetor(setor);
    }

/* Seleciona os Setores que atendem a uma condio inicial
 *
 *  @param   setor   Objeto Setor com as informaes necessrias
 *
 */

    public Setor[] selecionarSetor(Setor setor) {
       return rep.selecionarSetor(setor);

    }

    public boolean procurarSetor(Setor setor){
      return rep.procurarSetor(setor);
    }

/**  *  Inserir um Ponto de Venda no Setor
     *
     *@param   setor, pontoVenda   Objeto setor onde ser incluido o objeto pontoVenda
     */

    public void inserirPontoVendaSetor(Setor setor, PontoVenda pontoVenda) {

       rep.inserirPontoVendaSetor(setor, pontoVenda);
     }

/**  *  Excluir um Ponto de Venda no Setor
     *
     *@param  setor, pontoVenda  Objeto setor de onde ser excluido
     *                           o objeto pontoVenda
     */
     public void excluirPontoVendaSetor(Setor setor, PontoVenda pontoVenda) {

       rep.excluirPontoVendaSetor(setor, pontoVenda);
     }


/**  *  Devolve um array com todos os Setores
     *
     */

    public Setor[] getArraySetor() {
        return rep.getArraySetor();
    }


/**  *   Devolve um array com Ponto de Venda de um Setor
     *
     */


    public PontoVenda[] getArrayPontoVendaSetor(Setor setor) {
        return rep.getArrayPontoVendaSetor(setor);
    }


}  // fecha classe

