package setor;

import pontoVenda.PontoVenda;
import pontoVenda.RepositorioPontoVendaLista;



interface RepositorioSetor {





// .............. MTODOS ...........................


 /* Insere um novo setor na lista.
     *
     * @param           Uma pontoVenda a ser inserida.
     */
  public void inserirSetor(Setor setor);




 /* Exclui um Setor da lista.
     *
     * @param           Nome do Setor a ser excluido.
     */
    public void excluirSetor(Setor setor);



    /* Verifica se um dado Setor pertence  lista.
     *
     * @param           Setor a ser procurado.
     * @return          Resposta se o Setor existe.
     */
    public boolean procurarSetor(Setor setor);


    /* Verifica os Setores que satisfazem
     *  a determinadas caracteristicas de um setor dado
     *
     * @param           Setor com caractersticas.
     * @return          Array com setores que satisfazem.
     */
    public Setor[] selecionarSetor(Setor setor);



    /* Inserir pontoVenda no Setor
     *
     * @param       setor onde ser inserido o ponto de
     *              venda pontoVenda
     *
     * @return          Resposta se o Setor existe.
     */

    public void inserirPontoVendaSetor(Setor setor, PontoVenda pontoVenda);




    /* Excluir pontoVenda no Setor
     *
     * @param       setor onde ser excludo o ponto de
     *              venda pontoVenda
     *
     * @return          Resposta se o Setor existe.
     */


    public void excluirPontoVendaSetor(Setor setor, PontoVenda pontoVenda);




    /* Retorna um array de Setores
     *
     */

    public  Setor[]  getArraySetor();



    /* Retorna um array de pontoVendas do Setor
     *
     */

    public PontoVenda[] getArrayPontoVendaSetor(Setor setor);

} // Fecha Classe


