package setor;

import pontoVenda.PontoVenda;
import pontoVenda.RepositorioPontoVendaLista;

public class RepositorioSetorLista
              implements RepositorioSetor {

  public RepositorioSetorLista() {
  }
  // o Setor deste n da Lista
  private Setor noSetor;

 // referencia ao proximo elemento da lista
  private RepositorioSetorLista proxSetor;

// .............. MTODOS ...........................


 /* Insere um novo setor na lista.
     *
     * @param           Uma pontoVenda a ser inserida.
     */
  public void inserirSetor(Setor setor) {
        if (this.procurarSetor(setor) == false) {
            if (this.noSetor == null) {
               this.noSetor = setor;
               proxSetor = new RepositorioSetorLista();
             }
            else
             proxSetor.inserirSetor(setor);
         }
         else
               throw new RuntimeException ("Setor ja Cadastrado!");
    }

 /* Exclui um Setor da lista.
     *
     * @param           Nome do Setor a ser excluido.
     */
    public void excluirSetor(Setor setor) {
        RepositorioSetorLista repos = new RepositorioSetorLista();
        repos = this;
        if (this.noSetor == null)
                 throw new RuntimeException ("Setor inexistente");
        else {
            if (repos.noSetor.match(setor)) {
                repos.noSetor = proxSetor.noSetor;
                repos = repos.proxSetor;
            }
            else
                repos = repos.proxSetor;
                repos.excluirSetor(setor);
        }
    }


/* Procura se um dado setor pertence  lista.
 *
 * @param           Setor a ser procurado
 * @return          Resposta se o setor existe.
 */
	public boolean procurarSetor(Setor s){
		boolean resultado = false;
    Setor[] arrsetor = this.getArraySetor();
    Setor set = null;
    IteratorSetorArray itSetor = new IteratorSetorArray();

    if (s == null)
     return resultado;

    while (itSetor.hasNext(arrsetor)) {
      set = itSetor.next(arrsetor);
      if (set.match(s))
       return resultado = true;
    } // fecha o While
    return resultado;
  }



  // Inserir pontoVenda no Setor

    public void inserirPontoVendaSetor(Setor setor, PontoVenda pontoVenda){
        boolean s = this.procurarSetor(setor);
        if (s != false)
            setor.incluirpontoVendaSetor(pontoVenda);
        else
        {      throw new RuntimeException ("Setor nao Cadastrado!");}
     }

  // Excluir pontoVenda no Setor

    public void excluirPontoVendaSetor(Setor setor, PontoVenda pv){
        boolean s = this.procurarSetor(setor);
        if (s != false)
           setor.excluirPontoVendaSetor(pv);
        else
        {     throw new RuntimeException ("Setor nao Cadastrado!"); }
     }


    /* Verifica os Setores que satisfazem
     *  a determinadas caracteristicas de um setor dado
     *
     * @param           Setor com caractersticas.
     * @return          Array com setores que satisfazem.
     */
    public Setor[] selecionarSetor(Setor setor) {
      Setor[] arrSetor = this.getArraySetor();
      Setor[] selSetor;
      selSetor = new Setor[100];
      int indice = 0;
      IteratorSetorArray itSet = new IteratorSetorArray();
      Setor set = null;

      while (itSet.hasNext(arrSetor)) {
       set = itSet.next(arrSetor);
       if (set.match(setor)) {

        selSetor[indice] = set;
        indice = indice+1;
       } // fecha if

      } // fecha o while
      return selSetor;
    } // fecha o mtodo



   // Retorna um array de Setores

    public  Setor[]  getArraySetor() {
      Setor[] arraySetores;
      int indice = 0;
      RepositorioSetorLista repoSl = new RepositorioSetorLista();
      arraySetores = new Setor[100];

      repoSl = this;

      while (repoSl.noSetor != null)  {
         arraySetores[indice] = repoSl.noSetor;
         indice = indice+1;
         repoSl = repoSl.proxSetor;
        }

      return arraySetores;
    }

  // Retorna um array de pontoVendas do Setor

    public PontoVenda[] getArrayPontoVendaSetor(Setor setor) {
       Setor[] set = null;
       if (setor != null)
        set = this.selecionarSetor(setor);
       if (set != null)
           return set[1].getArrayPontoVenda();
        else
          return null;

     }

} // Fecha Classe


