package shopping;

import pontoVenda.CadastroPontoVenda;
import produto.CadastroProduto;
import setor.CadastroSetor;
import produto.CadastroMarca;
import produto.Marca;
import pontoVenda.PontoVenda;
import produto.Produto;
import setor.Setor;
import pontoVenda.Loja;
import produto.PerfilProduto;
import produto.OfertaProduto;
import produto.ProdutoJaCaException;
import produto.ProdutoNaoCaException;
import produto.PerfilJaCaException;
import produto.PerfilNaoCaException;
import produto.OfertaJaCaException;
import produto.OfertaNaoCaException;

public class Shopping {

  private CadastroMarca cadMarca;
  private CadastroSetor cadSetor;
  private CadastroPontoVenda cadPv;
  private CadastroProduto cadProduto;

  public Shopping(CadastroMarca cadMarca, CadastroSetor cadSetor,
  CadastroPontoVenda cadPv, CadastroProduto cadProduto) {
    this.cadMarca = cadMarca;
    this.cadSetor = cadSetor;
    this.cadPv = cadPv;
    this.cadProduto = cadProduto;

    }

//  *************   Mtodos de Marca *******************


    // Inserir Marca

    public void inserirMarca(Marca marca) {
        cadMarca.inserirMarca(marca);
        }

    	// Procura uma marca e  devolve true ou false

	  public boolean procurarMarca (Marca marca) {
		   return cadMarca.procurarMarca(marca);
	}

    // Devolve um array com Marca

    public Marca[] getArrayMarca() {
        return cadMarca.getArrayMarca();
        }

    // Devolve um conjunto de Marcas

    public Marca[] selecionarMarca(Marca marca) {
       return cadMarca.selecionarMarca(marca);
    }

//  *************   Mtodos de Setor *******************


    // Inserir Setor

    public void inserirSetor(Setor setor) {
        cadSetor.inserirSetor(setor);
        }

    // Inserir uma Loja num Setor

     public void inserirPontoVendaSetor(Setor setor, PontoVenda pontoVenda) {
      if (cadPv.procurarPontoVenda(pontoVenda))  {
       PontoVenda[] pvs = cadPv.selecionarPontoVenda(pontoVenda);
       pontoVenda=pvs[1];
       cadSetor.inserirPontoVendaSetor(setor, pontoVenda);
       }
       else
         throw new RuntimeException("Ponto de Venda no cadastrada!");

     }

      // Devolve conjunto de setores

     public Setor[] selecionarSetor(Setor setor) {
       return cadSetor.selecionarSetor(setor);

    }


    // Devolve um array com Setor

    public Setor[] getArraySetor() {
        return cadSetor.getArraySetor();
        }

    // Devolve um array com Pontos de Venda de um Setor

     public PontoVenda[] getArrayPontoVendaSetor(Setor setor) {
        return cadSetor.getArrayPontoVendaSetor(setor);
        }

    // Exclui um setor

    public void excluirSetor (Setor setor) {

    Produto[] arrayProduto =
            cadProduto.getArrayProduto();
    if (arrayProduto == null)
        cadSetor.excluirSetor(setor);
    else
        throw new RuntimeException("Setor no pode ser excludo. Existem Tipos de Produto!");

}

public boolean procurarSetor(Setor setor){
  return  cadSetor.procurarSetor(setor);
}

//  *************   Mtodos de Ponto de Venda *******************


    // Inserir Ponto de Venda

    public void inserirPontoVenda(PontoVenda pontoVenda) {
        cadPv.inserirPontoVenda(pontoVenda);
        }

    // Devolve um conjunto de Pontos de Venda

    public PontoVenda[] selecionarPontoVenda(PontoVenda pontoVenda) {
       return cadPv.selecionarPontoVenda(pontoVenda);

    }



    // Devolve um array com Ponto de Venda

    public PontoVenda[] getArrayPontoVenda() {
        return cadPv.getArrayPontoVenda();
        }

//  *************   Mtodos de Produto *******************


    // Inserir Produto

    public void inserirProduto(Produto produto) throws ProdutoJaCaException {
        cadProduto.inserirProduto(produto);
        }

     // Procura um Produto e o devolve true ou false

    public boolean procurarProduto(Produto produto) {
       return cadProduto.procurarProduto(produto);

    }

     // Inserir Perfil do Produto

    public void inserirPerfilProduto(Produto produto, PerfilProduto perfil)
      throws ProdutoNaoCaException, PerfilJaCaException {

        cadProduto.inserirPerfilProduto(produto, perfil);
        }

    // Inserir Oferta do Produto

    public void inserirOfertaProduto(Produto produto, PerfilProduto perfil,
       OfertaProduto oferta)
       throws ProdutoNaoCaException, PerfilNaoCaException, OfertaJaCaException {

        cadProduto.inserirOfertaProduto(produto, perfil, oferta);
        }

    // Altera preo de uma Oferta do Produto

    public void alterarPrecoOfertaProduto(Produto produto, PerfilProduto perfil,
     OfertaProduto oferta, double novoPreco)
     throws ProdutoNaoCaException, PerfilNaoCaException, OfertaNaoCaException {
        cadProduto.alterarPrecoOfertaProduto(produto, perfil, oferta, novoPreco);
        }

    // Exclui uma Oferta de um produto

    public void excluirOfertaProduto(Produto produto, PerfilProduto perfil,
      OfertaProduto oferta)
      throws ProdutoNaoCaException, PerfilNaoCaException, OfertaNaoCaException {
        cadProduto.excluirOfertaProduto(produto, perfil, oferta);
        }

    // Devolve um array com Produto

    public Produto[] getArrayProduto() {
        return cadProduto.getArrayProduto();
        }


    // Devolve um array com Perfis de um Produto

    public PerfilProduto[] getArrayPerfilProduto(Produto produto) {
        return cadProduto.getArrayPerfilProduto(produto);

        }

      // Devolve um array com Ofertas de um Produto

    public OfertaProduto[] getArrayOfertaProduto(Produto produto, PerfilProduto perfil) {
        return cadProduto.getArrayOfertaProduto(produto, perfil);
        }

      // Devolve um array de produtos com as caractersticas definidas

    public Produto[] selecionarProduto(Produto produto) {
      return cadProduto.selecionarProduto(produto);

    }

    /** Este metodo devolve um array de novos objetos produtos, filtrando no
     *  conjunto de produtos os produtos e seus respectivos perfis, desde que
     *  estes satisfacam a busca do usuario
     *
     *  @param produto Objeto contendo os atributos buscados pelo usuario
     */

     public Produto[] filtrarProdutos(Produto produto) throws PerfilJaCaException{
      return cadProduto.filtrarProdutos(produto);
      }

} // fecha a classe



